-- Shoot script --
--# manages tongue and bugs #--

-- Locals --
local x, y = 0, 0
local length, stretch = 1, 0.2
local bugAnim = {} -- animation frames
local frameCount = 8
local bugs = {}
local bugProb = {3.0, 0.15, 0.1, 0.05} -- probability of each type of bug appearing
local margin = 16


-- Functions --
function shootInit()
	bugAnim = {}
	bugs = {}
	tongue = love.graphics.newImage("assets/frogs/4.png")
	bugImg = love.graphics.newImage("assets/"..Theme.."/bugs.png")
	for i=0, frameCount-1, 1 do
		bugAnim[i] = love.graphics.newQuad(i*16, 0, 16, 16, bugImg:getDimensions())
	end
	for i=0, lines-1, 1 do
		local b = {x= (2*i+1)*(bx/(lines*2)), y= margin, bi = i, eaten= false, bType = 0, anim= 0, time= 0, animSpeed= math.random(1, 2)/10}
		table.insert(bugs, b)
	end
	x, y = player.x, player.y
end

function shootUpdate()
	x = player.x
	if player.shoot and not player.done then
		y = y - stretch*16*Level
		length = length + stretch*Level
	elseif not player.shoot and length > 1 then
		y = y + stretch*32*Level
		length = length - (stretch * 2)*Level
	else
		length = 1
		y = player.y
	end
	if y < 0 then player.shoot = false end
	
	-- bug update
	for i, bug in ipairs(bugs) do
		-- Animation code here --
		bug.time = bug.time + bug.animSpeed
		if bug.time > 1 then
			if bug.anim == 0 then
				bug.anim = 1
			else
				bug.anim = 0
			end
			bug.time = 0
		end
		if bug.y < margin then
			bug.y = bug.y + 0.5*Level
		end
		-- Eating code here --
		if math.abs(y - bug.y) < 8 and x == bug.x and not bug.eaten and player.shoot then
			bug.eaten = true
		end
		if bug.eaten then
			bug.y = y
			bug.x = x
			if bug.y > player.y-margin then
				-- Reset bug position --
				bug.y = -5 * margin
				bug.x = (2*bug.bi+1)*(bx/(lines*2))
				bug.eaten = false
				-- Score Code --
				Score = Score + (bug.bType+1)*gStage
				player.hunger = clamp(player.hunger - (2.5*hungerMultiplier + 3*bug.bType)/Level, hBarPad, bx-hBarPad)
				-- Power-ups --
				powerup(bug.bType)
				-- Change bug type and animSpeed --
				bug.bType = biasedRandom(bugProb)
				bug.animSpeed= math.random(1, 2)/10
			end
		end
	end
end

function shootDraw()
	draw(tongue, x, y, 1, length)
end

function bugDraw()
	local bugX, bugY = bugImg:getDimensions()
	for i, bug in ipairs(bugs) do
		love.graphics.draw(bugImg, bugAnim[bug.anim + bug.bType*2], bug.x - bugX/(frameCount*2), bug.y)
	end
end

function tonguePos()
	return y
end

function powerup(bType)
	if bType == 3 then
		Timer = Time
		player.protected = true
		Powerup:play()
	end
end




