-- Train script --
--# manages trains and collision #--

-- Globals and Locals --
local done = false
spawning = true
local img = ""
local trains = {}
local count = 0
local t = 0
local wait = 1.3
local maxWait = wait + 0.1
local speed = 1
local margin = 24

function trainInit()
	done = false
	spawning = true
	trains = {}
	count = 0
	t = 0
	img = love.graphics.newImage("assets/"..Theme.."/2.png")
	math.randomseed(os.time())
end

function trainDraw()
	for i, train in ipairs(trains) do
		draw(img, train.x, train.y)
	end
end

function trainUpdate(dt)
	ix, iy = img:getDimensions()
	if not done then
		-- adding new train
		t = t + dt
		if t > wait and spawning and t < maxWait then
			count = count + 1
			local i = math.random(0, lines-1)
			trn = {x = (bx/(lines*2) * (2*i + 1)), y = -16}
			table.insert(trains, trn)
			t = 0
		elseif t > maxWait then
			t = 0
		end
		-- move, check, remove
		if count > 0 then
			for i, train in ipairs(trains) do
				if train.y > (by + iy/2) then
					table.remove(trains, i)
					count = count - 1
				else
					train.y = train.y + speed*Level
				end
				-- player-train collision --
				if train.x == player.x and not player.protected and not player.done then
					if math.abs(train.y - player.y) < margin then
						gameOver()
					end
					if math.abs(train.y - tonguePos()) < margin then
						player.shoot = false
						if Vibrate then love.system.vibrate(0.01) end
					end
				end
			end
		end
	end
end





