-- UI script --
-- manages UI elements --

require "button"

-- Variables --
Sx, Sy = 0, 0 -- screen size
Scroll = 0
local ba, bb = 0, 0 -- for Scrolling bg
local sTimer, sTimeout = 0, 3
local staging = false
local menuMsg = "START"
local uTime = 0
local infoText = string.upper("\n.Controls.\n\nSwipe horizontally\n to change lane\n\nPress and hold\n to eat bugs"
	.."\n\nBring the hunger\nmeter at top to\nleft to proceed\nto the next stage."
	.."\n\n.Facts.\n\nThe pink bubblefly\ngives protection\nfor 10 seconds"
	.."\n....\n\n\nGame made only\nusing a phone\nby Bhgt"
	.."\n\nShow your love\nand support to the \ndeveloper\ndonate through the \nitch.io page")

-- Functions --
function uiInit()
	font = love.graphics.newImageFont("assets/font.png", characters)
	sFont = love.graphics.newImageFont("assets/sFont.png", characters)
	love.graphics.setFont(font)
	title = love.graphics.newImage("assets/Title.png")
	health = love.graphics.newImage("assets/ui/Health.png")
	pointer = love.graphics.newImage("assets/ui/Point.png")
	scoreboard = love.graphics.newImage("assets/ui/Score.png")
	replay = love.graphics.newImage("assets/ui/Replay.png")
	back = love.graphics.newImage("assets/ui/Back.png")
	settings = love.graphics.newImage("assets/ui/Settings.png")
	info = love.graphics.newImage("assets/ui/Info.png")
	play = love.graphics.newImage("assets/ui/Play.png")
	pauseImg =love.graphics.newImage("assets/ui/PausePanel.png")
	options = love.graphics.newImage("assets/ui/SettingsPanel.png")
	gameover = love.graphics.newImage("assets/ui/Gameover.png")
	arrowL = love.graphics.newImage("assets/ui/ArrowL.png")
	arrowR = love.graphics.newImage("assets/ui/ArrowR.png")
	musicImg = love.graphics.newImage("assets/ui/Music.png")
	soundImg = love.graphics.newImage("assets/ui/Sound.png")
	vibrateImg = love.graphics.newImage("assets/ui/Vibrate.png")
	l1 = love.graphics.newImage("assets/ui/L1.png")
	l2 = love.graphics.newImage("assets/ui/L2.png")
	l3 = love.graphics.newImage("assets/ui/L3.png")
	ba = 0
	bb = by
	Scroll = 0
	buttonInit()
end

function buttonInit()
	replayButton = newButton(replay, Sx/2, by/2)
	backButton = newButton(back, (Sx/2 - back:getWidth() - 1), by/2)
	settingsButton = newButton(settings, (Sx/2 + settings:getWidth() + 1), by/2)
	
	musicButton = newButton(musicImg, Sx/2, by/2)
	soundButton = newButton(soundImg, (Sx/2 - soundImg:getWidth() - 1), by/2)
	vibrateButton = newButton(vibrateImg, (Sx/2 + vibrateImg:getWidth() + 1), by/2)
	if Difficulty == 0.4 then diffButton = newButton(l1, Sx/2, by/2-17)
	elseif Difficulty == 0.5 then diffButton = newButton(l2, Sx/2, by/2-17)
	elseif Difficulty == 0.6 then diffButton = newButton(l3, Sx/2, by/2-17)
	end
	
	pausePanel = newButton(pauseImg, Sx/2, Sy/2 - 6)
	gameoverPanel = newButton(gameover, Sx/2, Sy/2 - 6)
	settingsPanel = newButton(options, Sx/2, Sy/2 - 11)
	
	playButton = newButton(play, Sx/2, Sy)
	infoButton = newButton(info, 0, Sy)
	leftButton = newButton(arrowL, Sx/2-18, Sy-24)
	rightButton = newButton(arrowR, Sx/2+18, Sy-24)
end

function uiUpdate(dt)
	uTime = uTime + dt
	if uTime > 0.3 and uTime < 0.5 then buttonInit() end -- work around for orentation displacing buttons bug
end

function uiDraw()
	Sx, Sy = love.graphics.getDimensions()
	Sx = Sx/SCREENSCALE
	Sy = Sy/SCREENSCALE
	
	if State == "menu" or State == "info" or lastState == "menu" then
		ba = ba + 0.5
		bb = bb + 0.5
		if ba > Sy then ba = bb - by end
		if bb > Sy then bb = ba - by end
		love.graphics.draw(bg, 0, math.floor(ba))
		love.graphics.draw(bg, 0, math.floor(bb))
	end
	
	if State == "menu" then
		uiMenu()
	elseif State == "settings" and lastState == "menu" then
		uiDrawSettings()
	elseif State == "info" then
		love.graphics.print(infoText, 0, math.floor(Scroll))
	else
		uiPlay()
		if State == "gameover" or State == "pause" then uiPause()
		elseif State == "settings" then uiDrawSettings() end
	end
end

function uiStage()
	sTimer = Time
	staging = true
end

function uiInput(x, y)
	x = x/SCREENSCALE
	y = y/SCREENSCALE
	
	if State == "menu" then
		settingsButton.x, settingsButton.y = (Sx-settingsButton.width/2), (Sy-settingsButton.height/2)
		-- main menu input handling --
		if playButton:pressed(x, y) then newGame()
		elseif settingsButton:pressed(x, y) then toggleSettings()
		elseif infoButton:pressed(x, y) then State = "info"; Scroll = 0; love.graphics.setFont(sFont)
		elseif leftButton:pressed(x, y) then
			player.char = clamp(player.char - 1, 0, 6)
			frogChange()
		elseif rightButton:pressed(x, y) then
			player.char = clamp(player.char + 1, 0, 6)
			frogChange()
		end
	elseif (State == "gameover" or State == "pause")then
		settingsButton.x, settingsButton.y = (Sx/2 + back:getWidth() + 1), by/2
		-- pause/gameover menu input handling --
		if replayButton:pressed(x, y) then newGame()
		elseif backButton:pressed(x, y) then reset(); State = "menu"
		elseif settingsButton:pressed(x, y) then toggleSettings() end
	elseif State == "settings" then
		uiSettings(x, y)
	end
end

function uiPlay()
	local x = math.floor(Sx/2 - (11*string.len(tostring(Score)))/2) -- for time
	local hy = (health:getHeight()/2) -- for health bar
	local ty = Sy - 16
	draw(scoreboard, Sx/2, ty - hy + 12)
	love.graphics.print(math.floor(Score), x, ty)
	draw(health, bx/2, hy)
	draw(pointer, player.hunger, hy)
	
	-- displaying stage --
	if staging then
		local text = ""
		if gStage == winStage then
			text = "YOU WON!"
		else
			text = "STAGE "..tostring(gStage)
		end
		x = math.floor(bx/2 - (11*string.len(text))/2) + 4
		love.graphics.print(text, x+4, by/2-32)
		
		-- Checking for timeout --
		if (Time - sTimer) > sTimeout then staging = false end
	end
end

function uiMenu()
	-- drawing --
	settingsButton.x = Sx
	settingsButton.y = Sy
	love.graphics.draw(title, 0, 0)
	infoButton:draw()
	settingsButton:draw()
	playButton:draw()
	
	-- Character selection --
	leftButton:draw()
	rightButton:draw()
	draw(player.img, Sx/2, Sy-24)
end

function uiPause()
	if State == "pause" then pausePanel:draw() else gameoverPanel:draw() end
	backButton:draw()
	replayButton:draw()
	settingsButton:draw()
end

function toggleSettings()
	lastState = State
	State = "settings"
end

function uiDrawSettings()
	settingsPanel:draw()
	if lastState == "menu" then diffButton:draw() end
	musicButton:draw()
	soundButton:draw()
	vibrateButton:draw()
end

function uiSettings(x, y)
	if musicButton:pressed(x, y) then
		toggleMusic()
	
	elseif soundButton:pressed(x, y) then
		toggleSound()
		Beep:play()
	
	elseif vibrateButton:pressed(x, y) then
		toggleVibrate()
		if Vibrate then love.system.vibrate(0.1) end
	
	elseif diffButton:pressed(x, y) and lastState == "menu" then
		if Difficulty == 0.4 then
			Difficulty = 0.5
			diffButton.image = l2
		elseif Difficulty == 0.5 then
			Difficulty = 0.6
			diffButton.image = l3
		elseif Difficulty == 0.6 then
			Difficulty = 0.4
			diffButton.image = l1
		end
	elseif lastState == "menu" then
		Theme = newTheme()
		reset()
	end
end








